//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------
#include <cassert>
#include <cstdlib>
#include <iostream>

struct BasicAllocator
{
	static float* Allocate(unsigned int _n) { return static_cast<float*>(malloc(_n*sizeof(float))); }
	static void Desallocate(float* _ptr) { free(reinterpret_cast<void*>(_ptr)); }
};
//-----------------------------------------------------------------------------
class Array
{
	public:
		Array(unsigned int _size=1);
		~Array();
		float& operator[](unsigned int _i);
		void push_back(const float& _val);
		unsigned int size() const;
		unsigned int capacity() const;

	private:		
		float* values;
		unsigned int storageCapacity;
		unsigned int last;
};


//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
Array::~Array()
{
	Allocator::Desallocate(values);
}
//-----------------------------------------------------------------------------
Array::Array(unsigned int _size):storageCapacity(_size),last(-1)
{
	storageCapacity = storageCapacity==0?1:storageCapacity;
	values 	= Allocator::Allocate(storageCapacity);
}
//-----------------------------------------------------------------------------
float& Array::operator[](unsigned int _i)
{
	assert(_i>=0);
	assert(_i<=last);
	return values[_i];
}
//-----------------------------------------------------------------------------
void Array::push_back(const float& _val)
{
	if(last==storageCapacity-1)
	{
		unsigned int newCapacity = 2*storageCapacity;
		float* newValues = Allocator::Allocate(newCapacity);

		for(unsigned int i=0;i<storageCapacity;++i)
			newValues[i] = values[i];
		
		Allocator::Desallocate(values);
		values = newValues;
		storageCapacity = newCapacity;
	}

	values[++last] = _val;
}
//-----------------------------------------------------------------------------
unsigned int Array::size() const
{
	return last+1;
}
//-----------------------------------------------------------------------------
unsigned int Array::capacity() const
{
	return storageCapacity;
}
//-----------------------------------------------------------------------------
int main()
{
	Array fa;
	fa.push_back(1.2f);
	fa.push_back(2.3f);
	fa[0];
	fa[1];
	fa.size();
	fa.capacity();

	Array fi;
	fi.push_back(1);
	fi.push_back(2);
	fi[0];
	fi[1];
	fi.size();
	fi.capacity();
	
	char c;
	std::cout << "Press any key, then enter...";
	std::cin >> c;
	return 0;
}
