//-----------------------------------------------------------------------------
// Includes
//-----------------------------------------------------------------------------
#include <cassert>
#include <iostream>


template<typename T, int Max>
class stack
{
	public:
		stack();
		void push(const T& _value);
		void pop();
		T& top();
	private:
		T values[Max];
		int index;
};
//-----------------------------------------------------------------------------
template<typename T, int Max>
stack<T,Max>::stack():index(-1)
{
	
}
//-----------------------------------------------------------------------------
template<typename T, int Max>
void stack<T,Max>::push(const T& _value)
{
	assert(index<Max);
	values[++index] = _value;
}
//-----------------------------------------------------------------------------
template<typename T, int Max>
void stack<T,Max>::pop()
{
	assert(index>=0);
	--index;
}
//-----------------------------------------------------------------------------
template<typename T, int Max>
T& stack<T,Max>::top()
{
	return values[index];
}

int main()
{
	// Stack de int
	stack<int,10> si;
	si.push(1);
	si.push(2);
	si.push(3);
	int ti = si.top();
	si.pop();
	si.pop();
	si.pop();

	// Stack de float
	stack<float,10> sf;
	sf.push(1.2f);
	sf.push(2.3f);
	sf.push(3.4f);
	float tf = sf.top();
	sf.pop();
	sf.pop();
	sf.pop();

	char c;
	std::cout << "Press any key, then enter...";
	std::cin >> c;
	return 0;
}
